{
TRegware 3.22 Demo
by WAK Productions
Programmed by Winston Kotzan

Demo for TRegware component for Delphi 5
}
unit demo1main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, regware2;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    TimeLimit: TEdit;
    Button2: TButton;
    StatusLabel: TLabel;
    Label3: TLabel;
    DaysLabel: TLabel;
    Label4: TLabel;
    LicenseIDBox: TEdit;
    Button3: TButton;
    Label5: TLabel;
    Label6: TLabel;
    OrganizationLabel: TLabel;
    Label7: TLabel;
    LicenseLabel: TLabel;
    Label8: TLabel;
    CodeSizeLabel: TLabel;
    Code: TEdit;
    Reg: TRegwareII;
    SiteLicenseBox: TCheckBox;
    GenerateIDBtn: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ShowNagScreen;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Expire;
    procedure LicenseIDBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LicenseIDBoxChange(Sender: TObject);
    procedure RegClockChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SiteLicenseBoxClick(Sender: TObject);
    procedure GenerateIDBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses demo1form2;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Reg.Days := StrToInt(TimeLimit.Text);
  Reg.SetUnregistered;
  Code.Text := Reg.RegCode;
  OrganizationLabel.Caption := Reg.Organization;
  LicenseLabel.Caption := Reg.LicenseID;
  DaysLabel.Caption := IntToStr(Reg.DaysLeft);
  if Reg.Registered then StatusLabel.Caption := 'Registered' else StatusLabel.Caption := 'Not Registered';
end;

procedure TForm1.ShowNagScreen;
begin
  // Must create form, because other forms may not have been created yet
  Form2 := TForm2.Create(Application);
  Form2.ShowModal;
  Form2.Release;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Reg.CheckExpired then Expire;
  if Reg.Registered then StatusLabel.Caption := 'Registered'
  else begin
    StatusLabel.Caption := 'Not Registered';
    ShowNagScreen;
  end;
  Code.Text := Reg.RegCode;
  OrganizationLabel.Caption := Reg.Organization;
  LicenseLabel.Caption := Reg.LicenseID;
  LicenseIDBox.Text := Reg.LicenseID;
  DaysLabel.Caption := IntToStr(Reg.DaysLeft);
  CodeSizeLabel.Caption := IntToStr(Reg.RegCodeSize);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Reg.DoRegistration(LicenseIDBox.Text, 'WAK Productions', Reg.CalculateCode(LicenseIDBox.Text)) = false then
    ShowMessage('Unable to register program!');
  Code.Text := Reg.RegCode;
  OrganizationLabel.Caption := Reg.Organization;
  LicenseLabel.Caption := Reg.LicenseID;
  DaysLabel.Caption := IntToStr(Reg.DaysLeft);
  if Reg.Registered then StatusLabel.Caption := 'Registered' else StatusLabel.Caption := 'Not Registered';
end;

procedure TForm1.Expire;
begin
  ShowMessage('Program Expired');
end;

procedure TForm1.LicenseIDBoxKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Code.Text := Reg.CalculateCode(LicenseIDBox.Text);
end;

procedure TForm1.LicenseIDBoxChange(Sender: TObject);
begin
  if Length(LicenseIDBox.Text) > Reg.MaxChars then
  begin
    raise Exception.Create('Too many characters!');
  end;
end;

procedure TForm1.RegClockChange(Sender: TObject);
begin
  ShowMessage('User has tampered with the system clock!');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if Reg.LicenseOptions.LicenseSource <> lsUserDefined then
  begin
    LicenseIDBox.Enabled := false;
    LicenseIDBox.Text := Reg.LicenseID;
  end;
end;

procedure TForm1.SiteLicenseBoxClick(Sender: TObject);
begin
  if SiteLicenseBox.Checked then
  begin
    Reg.LicenseOptions.LicenseType := ltSiteLicense;
    LicenseIDBox.Enabled := true;
    LicenseIDBox.Text := '';
    Reg.SetUnregistered;
    LicenseLabel.Caption := Reg.LicenseID;
  end else  // No site license
  begin
    if Reg.LicenseOptions.LicenseSource <> lsUserDefined then
    begin
      Reg.LicenseOptions.LicenseType := ltSingleUserLicense;
      LicenseIDBox.Enabled := false;
      LicenseIDBox.Text := Reg.LicenseID;
      LicenseLabel.Caption := Reg.LicenseID;
    end;
  end;
end;

procedure TForm1.GenerateIDBtnClick(Sender: TObject);
var
  i: integer;
  Str: string;
begin
  if Reg.LicenseOptions.LicenseType <> ltSiteLicense then
  begin
    Randomize;
    for i := 0 to 9 do
    begin
      Str := Str + IntToStr(Random(10));
    end;
    LicenseIDBox.Text := Str;
  end;
end;

end.
