// TRegware 3.20
// Compiler directives and customized settings

// Change these values to customize your program for greater security

{ *********************** Compiler Options *********************** }

// PACKED_RECORDS specifies the use of packed records to store info in registry.
// Undefine PACKED_RECORDS for compatibility with older versions of TRegware
//
{$UNDEF PACKED_RECORDS}


// If HIDE_SEED is defined, TRegware encrypts the Seed property using the
// SEED_STORAGE constant.  This makes the Seed value more difficult to find
// in the executable.
//
{$UNDEF HIDE_SEED}

// Unfortunately, Perl does not handle Int64 sized variables.  If you are
// using the attached Perl script, the Seed value will have to be adjusted.
// Defining PERL_SEED causes TRegware to take this adjustment into account.
// However, because the Perl script does not automatically make this adjustment,
// you will have to pass a different Seed value to the &calculate_code()
// function.  The included SeedCalculator.exe program tells you which seed
// number to pass to the Perl script.
//
{$UNDEF PERL_SEED}


// TRegware ignores site license settings if SITE_LICENSES is defined
//
{$UNDEF SITE_LICENSES}

const

// IT IS RECOMMENDED THAT YOU CHANGE ALL OF THE FOLLOWING VALUES FOR EACH
// OF YOUR PROGRAMS TO ENSURE GREATER SECURITY


// This value is used to help protect the seed value.  The Seed value
// is XOR'ed with SEED_STORAGE to make it harder for hackers to find
// and patch.  The programmer can change SEED_STORAGE to any 16 digit
// hexadecimal number
//
SEED_STORAGE=$24A31E2C991B6D48;

// Values read from the registry to determing whether the registered
// license is a site license or single-user license.  These values
// can be changed to any number.  The main reason for this is to make it
// difficult for a cracker to change the registry setting to a different
// license.
//
SITE_LICENSE=integer($625B620F);
SINGLE_USER_LICENSE=integer($311D80E5);


// Values used to confuse cracker trying to decrypt the
// registration code generator.
//
SPAGHETTI_1=integer($31416159);
SPAGHETTI_2=integer($15149872);


// Leave the following line alone
{$DEFINE PRO_VERSION}
